<?php

/*
 * OAuth2 Client Bundle
 * Copyright (c) KnpUniversity <http://knpuniversity.com/>
 *
 * For the full copyright and license information, please view the LICENSE
 * file that was distributed with this source code.
 */

namespace KnpU\OAuth2ClientBundle\DependencyInjection\Providers;

use KnpU\OAuth2ClientBundle\Client\Provider\DiscordClient;
use Symfony\Component\Config\Definition\Builder\NodeBuilder;

class DiscordProviderConfigurator implements ProviderConfiguratorInterface
{
    public function buildConfiguration(NodeBuilder $node)
    {
        // no custom options
    }

    public function getProviderClass(array $config)
    {
        return 'Wohali\OAuth2\Client\Provider\Discord';
    }

    public function getProviderOptions(array $config)
    {
        return [
            'clientId' => $config['client_id'],
            'clientSecret' => $config['client_secret'],
        ];
    }

    public function getPackagistName()
    {
        return 'wohali/oauth2-discord-new';
    }

    public function getLibraryHomepage()
    {
        return 'https://github.com/wohali/oauth2-discord-new';
    }

    public function getProviderDisplayName()
    {
        return 'Discord';
    }

    public function getClientClass(array $config)
    {
        return DiscordClient::class;
    }
}
